# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/1/3
import json
import os
import sys
import time
import requests
import urllib3
sys.path.append(os.getcwd())
from main.common import Common
from main.feishu_lib import Feishu
from main.shengshengyingyin_publish import Publish
proxies = {'http': None, 'https':None}


class Recommend:
    current = 1

    @classmethod
    def get_feeds(cls, log_type, crawler, oss_endpoint, env):
        while True:
            url = "https://videoflow-prd.zhufutv.vip/api/h5/video/video-main/get-list"
            payload = json.dumps({
                "current": int(cls.current),
                "size": 10,
                "data": {
                    "miniappAppid": "wx67080d80855515b9",
                    "version": "1"
                }
            })
            headers = {
                'Host': 'videoflow-prd.zhufutv.vip',
                'accept': '*/*',
                'content-type': 'application/json',
                'accept-language': 'zh-CN,zh-Hans;q=0.9',
                'user-agent': 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E217 MicroMessenger/6.8.0(0x16080000) NetType/WIFI Language/en Branch/Br_trunk MiniProgramEnv/Mac',
                'referer': 'https://servicewechat.com/wx67080d80855515b9/7/page-frame.html'
            }
            urllib3.disable_warnings()
            response = requests.post(url=url, headers=headers, data=payload, verify=False, proxies=proxies)
            cls.current += 1
            if response.json()['code'] != 2000000:
                Common.logger(log_type).warning(f'response:{response.text}\n')
            elif len(response.json()['data']) == 0:
                Common.logger(log_type).info('没有更多了~\n')
                cls.current = 1
                return
            else:
                feeds = response.json()['data']
                for i in range(len(feeds)):
                    # video_title
                    if 'title' not in feeds[i]:
                        video_title = 0
                    else:
                        video_title = feeds[i]['title']

                    # video_id
                    if 'no' not in feeds[i]:
                        video_id = 0
                    else:
                        video_id = feeds[i]['no']

                    # cover_url
                    if 'coverUrl' not in feeds[i]:
                        cover_url = 0
                    else:
                        cover_url = feeds[i]['coverUrl']

                    # video_url
                    if 'realUrl' not in feeds[i]:
                        video_url = 0
                    else:
                        video_url = feeds[i]['realUrl']

                    Common.logger(log_type).info(f'video_title:{video_title}')
                    Common.logger(log_type).info(f'video_id:{video_id}')
                    Common.logger(log_type).info(f'cover_url:{cover_url}')
                    Common.logger(log_type).info(f'video_url:{video_url}')
                    video_dict = {'video_title': video_title,
                                  'video_id': video_id,
                                  'cover_url': cover_url,
                                  'video_url': video_url}
                    cls.download_publish(log_type, crawler, video_dict, oss_endpoint, env)

    @classmethod
    def download_publish(cls, log_type, crawler, video_dict, oss_endpoint, env):
        video_id = video_dict['video_id']
        video_title = video_dict['video_title']
        cover_url = video_dict['cover_url']
        video_url = video_dict['video_url']
        if video_title == 0 or video_id == 0 or cover_url == 0 or video_url == 0:
            Common.logger(log_type).info('无效视频\n')
        elif video_id in [x for y in Feishu.get_values_batch(log_type, 'ssyy', '59f11d') for x in y]:
            Common.logger(log_type).info('视频已下载\n')
        else:
            # 下载
            Common.download_method(log_type, 'cover', video_title, cover_url)
            Common.download_method(log_type, 'video', video_title, video_url)
            with open("./videos/" + video_title + "/" + "info.txt", "a", encoding="UTF-8") as f_a:
                f_a.write(str(video_id) + "\n" +
                          str(video_title) + "\n" +
                          '300' + "\n" +
                          '100000' + "\n" +
                          '100000' + "\n" +
                          '100000' + "\n" +
                          '100000' + "\n" +
                          '1920*1080' + "\n" +
                          str(int(time.time())) + "\n" +
                          '胜胜影音' + "\n" +
                          str(cover_url) + "\n" +
                          str(video_url) + "\n" +
                          str(cover_url) + "\n" +
                          "shengshengyingyin" + str(int(time.time())))
            Common.logger(log_type).info("==========视频信息已保存至info.txt==========")

            # 上传
            our_video_id = Publish.upload_and_publish(log_type, crawler, oss_endpoint, env, 'recommend')
            if env == 'dev':
                our_video_link = "https://testadmin.piaoquantv.com/cms/post-detail/" + str(our_video_id) + "/info"
            else:
                our_video_link = "https://admin.piaoquantv.com/cms/post-detail/" + str(our_video_id) + "/info"
            Common.logger(log_type).info("视频上传完成")

            # 视频信息写入飞书
            Feishu.insert_columns(log_type, 'ssyy', "59f11d", "ROWS", 1, 2)
            upload_time = int(time.time())
            values = [[time.strftime("%Y/%m/%d %H:%M:%S", time.localtime(upload_time)),
                       "推荐榜",
                       video_title,
                       video_id,
                       our_video_link,
                       cover_url,
                       video_url]]
            time.sleep(1)
            Feishu.update_values(log_type, 'ssyy', "59f11d", "F2:Z2", values)
            Common.logger(log_type).info(f"视频已保存至云文档:{video_title}\n")

if __name__ == '__main__':
    # 本地测试环境
    Recommend.get_feeds('recommend', 'ssyy', 'out', 'dev')

    # # 102 服务器正式环境
    # Recommend.get_feeds('recommend', 'ssyy', 'inner', 'prod')